#!/usr/bin/env python
#
# fm-ai.py
#

# Copyright (c) 2009, Florian Reichel
# All rights reserved.

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   * Redistributions of source code must retain the above copyright notice,
#		this list of conditions and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright
#		notice, this list of conditions and the following disclaimer in the
#		documentation and/or other materials provided with the distribution.
#   * Neither the name of the Copyright-holder nor the names of its
#		contributors may be used to endorse or promote products derived from
#		this software without specific prior written permission.

#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
#ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
#WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
#
#FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
#DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
#SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
#CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
#OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#SUCH DAMAGE.

# if necessary, change pathes

# Improvement:
#
# check if field is number, when number, look if the next fields are numbers
# too. Add the value. Print the value + position in dict
#
# Improvment: faster, all possibilities found.

# To-do:
# --------------------------------------------------------------
#
# read ki-name			--- needs testing
#
# interface human
#
# priority-function in logic.py:
#		program the comments
#
# solution-function in logic.py:
#		need_object like GGG/BBB finding
#		need_object like xxx/555
#
# calculate lilac-move ---> next-field what can you do (any numbers ?)
# 
# calculating own fields to test ki (need_object-list)
#
# --------------------------------------------------------------

import sys
from parsing import *
from logic import *
from find import *

def main():
	freturn = open("result.dat", "w+")
	which_player = True
	
	if len(sys.argv) < 2:
		print "Error, no argument [player] given"
	
	if int(sys.argv[1]) == 1:
		which_player = False
	else:
		which_player = True
	
	# initialize Data
	data = Parser()
	
	field = data.field()
	player, opponent = data.player(which_player)
	
	# initialize Searching-Engine
	find = Find(field)
	
	# find pairs
	pairs = find.result()

	print "Pairs: "
	for i in pairs:
		print "{%s}[%s]" % ( i , pairs[i] )
#	print "==========================="
	
	# calculating best movement
	print player
	
	ai = Logic(pairs,player,opponent)
	move = ai.solution()
	
	# returning result
	print move
	if move == -1:
		print "no move is possible !\n"
		move = "1 0 1 1"
	freturn.write(move)
	
	# clean up
	freturn.close()

if __name__ == "__main__":
	main()
